unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OleCtrls, ActiveMap_TLB, Menus, StdCtrls, ExtCtrls, ComCtrls;

type
  TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    ControlsCheckBox: TCheckBox;
    GroupBox3: TGroupBox;
    CameraEdit: TEdit;
    TargetEdit: TEdit;
    LightAzScrollBar: TScrollBar;
    LightAltScrollBar: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    RenderComboBox: TComboBox;
    Label3: TLabel;
    MistScrollBar: TScrollBar;
    Label4: TLabel;
    GraduatedCheckBox: TCheckBox;
    Label5: TLabel;
    SkyButton: TButton;
    MistButton: TButton;
    GroundButton: TButton;
    SkyShape: TShape;
    MistShape: TShape;
    GroundShape: TShape;
    RichEdit1: TRichEdit;
    ColorDialog1: TColorDialog;
    PositionButton: TButton;
    Label6: TLabel;
    Label7: TLabel;
    PerspectiveScrollBar: TScrollBar;
    Label8: TLabel;
    LoadButton: TButton;
    ActiveFormGLX: TActiveFormGLX;
    ShadeCheckBox: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure ControlsCheckBoxClick(Sender: TObject);
    procedure SkyButtonClick(Sender: TObject);
    procedure MistButtonClick(Sender: TObject);
    procedure GroundButtonClick(Sender: TObject);
    procedure GraduatedCheckBoxClick(Sender: TObject);
    procedure MistScrollBarChange(Sender: TObject);
    procedure RenderComboBoxChange(Sender: TObject);
    procedure LightAzScrollBarChange(Sender: TObject);
    procedure LightAltScrollBarChange(Sender: TObject);
    procedure PositionButtonClick(Sender: TObject);
    procedure PerspectiveScrollBarChange(Sender: TObject);
    procedure LoadButtonClick(Sender: TObject);
    procedure ShadeCheckBoxClick(Sender: TObject);
  private
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses about;

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  SkyShape.Brush.Color    := ActiveFormGLX.BackGroundColor;
  MistShape.Brush.Color   := ActiveFormGLX.HorizonColor;
  GroundShape.Brush.Color := ActiveFormGLX.GroundColor;
end;

//----------------------------------------------------------------------------//
procedure TMainForm.ControlsCheckBoxClick(Sender: TObject);
begin
  ActiveFormGLX.DisplayControls := ControlsCheckBox.Checked;
  CameraEdit.Enabled     := not ControlsCheckBox.Checked;
  TargetEdit.Enabled     := not ControlsCheckBox.Checked;
  PositionButton.Enabled := not ControlsCheckBox.Checked;
end;


//----------------------------------------------------------------------------//
procedure TMainForm.SkyButtonClick(Sender: TObject);
begin
  ColorDialog1.Color := SkyShape.Brush.Color;
  if ColorDialog1.Execute then begin
    SkyShape.Brush.Color := ColorDialog1.Color;
    ActiveFormGLX.BackGroundColor := SkyShape.Brush.Color;
    ActiveFormGLX.ExecGLRedraw;
  end;
end;

//----------------------------------------------------------------------------//
procedure TMainForm.MistButtonClick(Sender: TObject);
begin
  ColorDialog1.Color := MistShape.Brush.Color;
  if ColorDialog1.Execute then begin
    MistShape.Brush.Color := ColorDialog1.Color;
    ActiveFormGLX.HorizonColor := MistShape.Brush.Color;
    ActiveFormGLX.ExecGLRedraw;
  end;
end;

//----------------------------------------------------------------------------//
procedure TMainForm.GroundButtonClick(Sender: TObject);
begin
  ColorDialog1.Color := GroundShape.Brush.Color;
  if ColorDialog1.Execute then begin
    GroundShape.Brush.Color := ColorDialog1.Color;
    ActiveFormGLX.GroundColor := GroundShape.Brush.Color;
    ActiveFormGLX.ExecGLRedraw;
  end;
end;

//----------------------------------------------------------------------------//
procedure TMainForm.GraduatedCheckBoxClick(Sender: TObject);
begin
  ActiveFormGLX.ShowHorizon := GraduatedCheckBox.Checked;
  ActiveFormGLX.ExecGLRedraw;
end;

//----------------------------------------------------------------------------//
procedure TMainForm.MistScrollBarChange(Sender: TObject);
begin
  ActiveFormGLX.MistLevel := MistScrollBar.Position / 100.0;
  ActiveFormGLX.ExecGLRedraw;
end;

//----------------------------------------------------------------------------//
procedure TMainForm.RenderComboBoxChange(Sender: TObject);
begin
  ActiveFormGLX.Render := RenderComboBox.Text;
  ActiveFormGLX.ExecGLRestart;
end;

//----------------------------------------------------------------------------//
procedure TMainForm.LightAzScrollBarChange(Sender: TObject);
begin
  ActiveFormGLX.LightAz := LightAzScrollBar.Position;
  ActiveFormGLX.ExecGLRedraw;
end;

//----------------------------------------------------------------------------//
procedure TMainForm.LightAltScrollBarChange(Sender: TObject);
begin
  ActiveFormGLX.LightAlt := LightAltScrollBar.Position;
  ActiveFormGLX.ExecGLRedraw;
end;


//----------------------------------------------------------------------------//
procedure TMainForm.PositionButtonClick(Sender: TObject);
begin
  ActiveFormGLX.CameraPosition := CameraEdit.Text;
  ActiveFormGLX.TargetPosition := TargetEdit.Text;
  ActiveFormGLX.ExecGLUpdate;
end;


//----------------------------------------------------------------------------//
procedure TMainForm.PerspectiveScrollBarChange(Sender: TObject);
begin
  ActiveFormGLX.Perspective := PerspectiveScrollBar.Position;
  ActiveFormGLX.ExecGLRestart;
end;

//----------------------------------------------------------------------------//
procedure TMainForm.LoadButtonClick(Sender: TObject);
begin
  if LoadButton.Caption = 'Load Lomond' then begin
    ActiveFormGLX.TIN     := 'lomond.tin';
    ActiveFormGLX.overlay := 'lomfract.bmp';
    LoadButton.Caption    := 'Load Tatras';
  end
  else begin
    LoadButton.Caption    := 'Load Lomond';
    ActiveFormGLX.TIN     := 'tatras.tin';
    ActiveFormGLX.overlay := 'tatras.bmp';
  end;

  ActiveFormGLX.ExecGLRestart;
end;

//----------------------------------------------------------------------------//
procedure TMainForm.ShadeCheckBoxClick(Sender: TObject);
begin
  ActiveFormGLX.ShadeTexture := ShadeCheckBox.Checked;
  ActiveFormGLX.ExecGLRestart;
end;

end.

